org.apache.flume.source

## Class NetcatSource

- java.lang.Object
- - org.apache.flume.source.AbstractSource
  - - org.apache.flume.source.NetcatSource

- All Implemented Interfaces:
    Configurable, EventDrivenSource, LifecycleAware, NamedComponent, Source

      public class NetcatSource
      extends AbstractSource
      implements Configurable, EventDrivenSource

  A netcat-like source that listens on a given port and turns each line of text into an event.

  This source, primarily built for testing and exceedingly simple systems, acts like `nc -k -l [host] [port]`. In other words, it opens a specified port and listens for data. The expectation is that the supplied data is newline separated text. Each line of text is turned into a Flume event and sent via the connected channel.

  Most testing has been done by using the `nc` client but other, similarly implemented, clients should work just fine.

  Configuration options

  Parameter | Description | Unit / Type | Default
  --- | --- | --- | ---
  `bind` | The hostname or IP to which the source will bind. | Hostname or IP / String | none (required)
  `port` | The port to which the source will bind and listen for events. | TCP port / int | none (required)
  `max-line-length` | The maximum # of chars a line can be per event (including newline). | Number of UTF-8 characters / int | 512

  Metrics

  TODO

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `NetcatSource()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `configure(Context context)` Request the implementing class to (re)configure itself.
    `void` | `start()` Starts a service or component.
    `void` | `stop()` Stops a service or component.

    - ### Methods inherited from class org.apache.flume.source.AbstractSource

      `getChannelProcessor, getLifecycleState, getName, setChannelProcessor, setName, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.flume.Source

      `getChannelProcessor, setChannelProcessor`

    - ### Methods inherited from interface org.apache.flume.lifecycle.LifecycleAware

      `getLifecycleState`

    - ### Methods inherited from interface org.apache.flume.NamedComponent

      `getName, setName`

- - ### Constructor Detail

    - #### NetcatSource

          public NetcatSource()

  - ### Method Detail

    - #### configure

          public void configure(Context context)

      Description copied from interface: `Configurable`

      Request the implementing class to (re)configure itself.

      When configuration parameters are changed, they must be reflected by the component asap.

      There are no thread safety guarantees on when configure might be called.

      Specified by:
        `configure` in interface `Configurable`

    - #### start

          public void start()

      Description copied from interface: `LifecycleAware`

      Starts a service or component.

      Implementations should determine the result of any start logic and effect the return value of `LifecycleAware.getLifecycleState()` accordingly.

      Specified by:
        `start` in interface `LifecycleAware`
      Overrides:
        `start` in class `AbstractSource`

    - #### stop

          public void stop()

      Description copied from interface: `LifecycleAware`

      Stops a service or component.

      Implementations should determine the result of any stop logic and effect the return value of `LifecycleAware.getLifecycleState()` accordingly.

      Specified by:
        `stop` in interface `LifecycleAware`
      Overrides:
        `stop` in class `AbstractSource`

Copyright © 2009-2016 Apache Software Foundation. All Rights Reserved.